/*
 *	main.c
 */

#include "dinv.h"

/*
 *	PutTitle
 */
static void PutTitle()
{
	Put8Str("Digital Invader for GBA", 0, 2);
	Put8Str("      version 0.3", 0, 3);
	Put8Str("  (C) 2006 by yasuho", 0, 4);
}

/*
 *	InitScreen
 */
static void InitScreen()
{
	vu16		*v, *ve;

	WRITE_REG16(LCD_CTL, 0x0403);	// BG2:Mode3

	v = (vu16 *)VRAM_ADDR;
	ve = (vu16 *)VRAM_ADDR + SCREEN_WIDTH * SCREEN_HEIGHT;
	while (v < ve)
		*v++ = 0;
}

/*
 *	Init
 */
static void Init()
{
	InitScreen();
	InitTimer();
	InitKey();

	InitLED(32, 32);
	InitFont8(10, 10);
	InitSRAM();
	InitGame();

	PutTitle();
}

/*
 *	AgbMain
 */
void AgbMain(void)
{
	u32		tick;
	u16		key;

	Init();

	for (;;) {
		FlashTextAndWait(3, 0, "Push Start Key", KEY_START, INFINITE);

		StartGame();

		for (;;) {
			InitStage();

			for (;;) {
				StartStage();

				switch (PlayGame()) {
				case PG_FAILURE:
					continue;
				case PG_STAGECLEAR:
					goto clear;
				case PG_GAMEOVER:
					goto end;
				}
			}
		clear:
			NextStage();
		}
	end:
		GameOver();
	}
}
