/*
 *	gbafs.h
 */

#ifndef _GBAFS_H_
#define _GBAFS_H_

#include <gba.h>

/*
 *	ROM file system
 */

#define MAX_ROMFS_SIZE	(32*1024*1024)

#define ROMFS_CHUNK	16	// Must be power of 2

#pragma pack(1)

typedef struct _ROMDIRENT {
	u8		attr;
	u8		namesize;
	u16		reserved;
	u8 *		fileaddr;
	u32		filesize;
	u32		filetime;
} ROMDIRENT, *PROMDIRENT;

#define DA_FILE		0x00
#define DA_DIR		0x80

typedef struct _ROMFSHEAD {
	u8		signature[2];
	u8		version;
	u8		reserved1;
	u16		size;
	u8		reserved2[10];
	ROMDIRENT	rootDir;
} ROMFSHEAD, *PROMFSHEAD;

#define ROMFSSIG	"GF"

#pragma pack()

/*
 *	File system
 */

typedef ROMDIRENT	DIRENT;
typedef DIRENT		*PDIRENT;

/*
 *	External functions
 */

BOOL FsInit();
PDIRENT FsGetRootDir();
PDIRENT FsGetDirEnt(u8 *path);

#endif // _GBAFS_H_

