/*
 *	scrn.h
 */

#ifndef _SCRN_H_
#define _SCRN_H_

#include <gba.h>

/*
 *	screen object
 */

typedef struct _SCRNOBJ {
	vu16	*(*ScrnPosToVram)(int x, int y);
	int	nextx;
	int	nexty;
	int	width;
	int	height;
} SCRNOBJ, *PSCRNOBJ;

#define SM_HORZ		0
#define SM_VERTRIGHT	1
#define SM_VERTLEFT	2
#define SM_LAST		3

#define GetScrnNextX(pso)	((pso)->nextx)
#define GetScrnNextY(pso)	((pso)->nexty)
#define GetScrnWidth(pso)	((pso)->width)
#define GetScrnHeight(pso)	((pso)->height)

/*
 *	bitmap
 */

typedef struct _BITMAP {
	int		width;
	int		height;
	const u16	*pimage;
} BITMAP, *PBITMAP;

/*
 *	macros
 */

/*
 *	globals
 */

extern PSCRNOBJ (*GetScrnObject)();
extern void (*GetScrnColor)(u16 *pfgcolor, u16 *pbgcolor);

/*
 *	functions
 */

/* scrnobj.c */
int SetScrnMode(int mode);
int GetScrnMode();
attriwram PSCRNOBJ iwGetScrnObject();
extern PSCRNOBJ (*GetScrnObject)();

/* scrn.c */
void ClearScrn();
void FillScrn(int x, int y, int width, int height, u16 c);
void BoxScrn(int x, int y, int width, int height, u16 c);
void EraseScrn(int x, int y, int width, int height);
void ReverseScrn(int x, int y, int width, int height);
void CopyBitmap16(PBITMAP pbm, int x, int y, u16 transparent);
void SetScrnColor(u16 fgcolor, u16 bgcolor);
attriwram void iwGetScrnColor(u16 *pfgcolor, u16 *pbgcolor);
extern void (*GetScrnColor)(u16 *pfgcolor, u16 *pbgcolor);
void ScrnInit();

#endif	// _SCRN_H_

